//
//  ViewController.m
//  WiMaster_Test_iPhne4
//
//  Created by 石井 孝佳 on 13/08/20.
//  Copyright (c) 2013年 石井 孝佳. All rights reserved.
//

#import "ViewController.h"
#import "WiFiConnect.h"

#define ON_BUTTON 0
#define OFF_BUTTON 1

@interface ViewController ()

@end

@implementation ViewController{
    NSInputStream* _readStream;
    NSOutputStream* _writeStream;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	
    //---センサー値結果のテキストフィールド生成---
    _textField=[[UITextField alloc] init];
    [_textField setFrame:CGRectMake(0,10,100,30)];  //位置と大きさ設定
    [_textField setText:@"result"];
    [_textField setBackgroundColor:[UIColor whiteColor]];
    [_textField setBorderStyle:UITextBorderStyleRoundedRect];
    [self.view addSubview:_textField];
    
    //---ONボタン生成---
    _onButton=[UIButton buttonWithType:UIButtonTypeRoundedRect];
    [_onButton setFrame:CGRectMake(0,80,250,40)];  //位置と大きさ設定
    [_onButton setTitle:@"LED ON" forState:UIControlStateNormal];
    [_onButton setTag:ON_BUTTON];           //ボタン識別タグ
    [_onButton addTarget:self action:@selector(onButtonClick:) forControlEvents:UIControlEventTouchUpInside];             //ボタンクリックイベント登録
    [self.view addSubview:_onButton];
    
    //---OFFボタン生成---
    _offButton=[UIButton buttonWithType:UIButtonTypeRoundedRect];
    [_offButton setFrame:CGRectMake(0,150,250,40)];  //位置と大きさ設定
    [_offButton setTitle:@"LED OFF" forState:UIControlStateNormal];
    [_offButton setTag:OFF_BUTTON];           //ボタン識別タグ
    [_offButton addTarget:self action:@selector(onButtonClick:) forControlEvents:UIControlEventTouchUpInside];             //ボタンクリックイベント登録
    [self.view addSubview:_offButton];
    
    //---WiMasterに接続---
    [self connect];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


//////////////////////////////////////////////////////////////
//  WiMasterと接続
//////////////////////////////////////////////////////////////
-(void)connect
{
    _conn = [[WiFiConnect alloc] initWithHostName:@"1.2.3.4" port:2000 timeout:30];
    _conn.delegate = self; //受信イベント受け取りの為、デリゲートをセット
    if([_conn openSocket]){
        NSLog(@"openSocket success");
    }else{
        NSLog(@"openSocket Error");
    }
}

//////////////////////////////////////////////////////////////
//  デストラクタ
//////////////////////////////////////////////////////////////
-(void)dealloc
{
    [_conn closeSocket];
}



//////////////////////////////////////////////////////////////
//  ボタンクリックイベント
//////////////////////////////////////////////////////////////
-(IBAction)onButtonClick:(UIButton*)sender{
    if(sender.tag==ON_BUTTON){
        [self send:0x01];
    }else if(sender.tag==OFF_BUTTON){
        [self send:0x00];
    }
}

//////////////////////////////////////////////////////////////
//  データ送信
//////////////////////////////////////////////////////////////
-(void) send:(int)data
{
    uint8_t sndData[1];
    sndData[0]=data;
    [_conn writeData:sndData length:1];
}


//////////////////////////////////////////////////////////////
//  データ受信イベント（WiFiConnectより）
//////////////////////////////////////////////////////////////
-(void)WiFiDataReceived:(NSMutableData *)data{
    NSLog(@"data=%@",data);
    //センサーデータ抽出
    int result = [self checkSensorValue:data];
    //画面に表示
    [_textField setText:[NSString stringWithFormat:@"%d",result]];
    
}

//返信dataから先頭から2バイト目を返す
-(int)checkSensorValue:(NSMutableData *)data{
    //MutableDataをbyte配列に変換
    int len = [data length];
    Byte rsvData[len];
    [data getBytes:&rsvData length:len];
    return rsvData[1];  //２バイト目
}



@end
